package at.tugraz.iaik.p2p

import at.tugraz.iaik.p2p.commons.CommonCrypto
import at.tugraz.iaik.p2p.evt.Event
import at.tugraz.iaik.p2p.evt.EvtNode
import at.tugraz.iaik.p2p.hkad.config.Config
import java.nio.ByteBuffer

suspend fun main(args: Array<String>) {
    val config = Config(CommonCrypto.genKP(false), listenAddr = "localhost:1916")
    val en1 = EvtNode(config)

    for (i in 1..12) {
        val conf2 = Config(CommonCrypto.genKP(false), listenAddr = "localhost:${1968 + i}")
        val en2 = EvtNode(conf2)
        en2.bootstrap(en1)
    }
    val genesis = Event(
        en1.identifier.fromData(ByteBuffer.wrap("crit1".toByteArray())),
        byteArrayOf(),
        byteArrayOf(),
        config.privateKey!!
    )
    val res = en1.pub(genesis)
    println(res)

    val fail = en1.pub(genesis)
    println(fail)

    val append = en1.pub(
        Event(
            en1.identifier.fromData(ByteBuffer.wrap("crit1".toByteArray())),
            byteArrayOf(),
            genesis.digest,
            config.privateKey!!
        )
    )
    println(append)

    val conf2 = Config(CommonCrypto.genKP(false), listenAddr = "localhost:2968")
    val en2 = EvtNode(conf2)
    en2.bootstrap(en1)
    val allEvents = en2.poll(en1.identifier.fromData(ByteBuffer.wrap("crit1".toByteArray())), byteArrayOf())

    println(allEvents)
}

