package at.tugraz.iaik.p2p.hkad.id

import at.tugraz.iaik.p2p.commons.CommonCrypto
import at.tugraz.iaik.p2p.commons.encode
import java.security.interfaces.ECPublicKey

class ECID private constructor(val publicKeyBytes: ByteArray, val publicKey: ECPublicKey) :
    SHA3ID(CommonCrypto.sha3(publicKeyBytes), true) {
    constructor(publicKey: ECPublicKey) : this(publicKey.encode(), publicKey)
    constructor(publicKeyBytes: ByteArray) : this(publicKeyBytes, CommonCrypto.decode(publicKeyBytes))
}