package at.tugraz.iaik.p2p.hkad.id

import at.tugraz.iaik.p2p.commons.CommonCrypto
import java.nio.ByteBuffer

open class SHA3ID protected constructor(data: ByteArray, derived: Boolean) :
    Identifier(data, if (derived) Type.EC else Type.SHA3) {

    constructor(data: ByteArray) : this(data, false)

    override fun fromData(data: ByteBuffer) = SHA3ID(CommonCrypto.sha3(data), false)

    override fun generateBydistance(dist: Int) = SHA3ID(bitsByDistance(dist), false)
}