package at.tugraz.iaik.p2p.hkad.msg

import at.tugraz.iaik.p2p.hkad.id.Identifier
import at.tugraz.iaik.p2p.hkad.node.Node

/**
 * Same as FIND_NODE, but if the recipient of the request has the requested key in its store, it will return the
 * corresponding value.
 *
 *
 * Created by Christoph on 22.09.2016.
 */

class FindValue(seqId: Long, origin: Node, val key: Identifier) : Message(MessageType.FIND_VALUE, seqId, origin)

class ValueReply(seqId: Long, origin: Node, val value: ByteArray) : Message(
    MessageType.VALUE_REPLY,
    seqId,
    origin
)
