package at.tugraz.iaik.p2p

import at.tugraz.iaik.p2p.commons.CommonCrypto
import at.tugraz.iaik.p2p.hkad.config.Config
import at.tugraz.iaik.p2p.hkad.id.Identifier
import at.tugraz.iaik.p2p.hkad.id.KadID
import at.tugraz.iaik.p2p.hkad.id.KeyBits
import at.tugraz.iaik.p2p.hkad.node.LocalNode
import kotlinx.coroutines.delay
import mu.KotlinLogging
import java.net.BindException
import java.nio.ByteBuffer
import java.util.*

suspend fun main() {

/*    val n = LocalNode(Config(keyPair = CommonCrypto.genKP(ed = false), listenAddr = "127.0.0.1:9650"))
    n.config.id.toString()
    for (i in 1..10) {
        runBlocking {
            val n2 =
                LocalNode(Config(keyPair = CommonCrypto.genKP(ed = false), listenAddr = "127.0.0.1:${9650 + i}"))
            n2.config.id.toString()
            n.routingTable.add(NodeInfo(n2, System.currentTimeMillis().toULong()))
        }
    }
    println(n.routingTable)*/

    for (i in 10 downTo 1){
        println(i)
        delay(1000)
    }

    val nx = LocalNode(
        Config(
            nodeId = KadID(ByteArray(Identifier.Type.KAD.numBits/8)),
            listenAddr = "127.0.0.1:9750"
        )
    )
    nx.config.id.toString()
    val nodes = mutableListOf<LocalNode>()
    for (i in 0..63) {
        val idBis = ByteArray(Identifier.Type.KAD.numBits.toInt()/8)
        for (h in 0 until idBis.size) {
            idBis[h] = (i*4).toByte()
        }
        try {

            val n2 = LocalNode(Config(KadID(idBis), listenAddr = "127.0.0.1:${9750 + i}"))
            n2.config.id.toString()
            nodes.add(n2)
            n2.bootstrap(nx)
        } catch (t: BindException) {
            KotlinLogging.logger("127.0.0.1:${9750 + i}").warn(t) { t.message }
        }

    }
    println(nx.routingTable)
    val rnd = ByteArray(Identifier.Type.KAD.numBits / 8).apply { CommonCrypto.RND.nextBytes(this) }
    val target = nx.id.fromData(ByteBuffer.wrap(rnd))
    val closest = nx.find(target, lookingForNode = true).closestNodes
    println(nx.put(rnd))
    println("closest for target $target: ${closest.map { it.id }}")
    println(nodes.last().routingTable)
    println(
        nodes.last().get(target)
    )
    println(nodes.map { it.id })

    nodes.forEach { it.close() }
}

